#include <lfulib.h>

// global arrays
static double vv[BASIS + 1];

// xludcmp()
void xludcmp(
    double a[BASIS + 1][BASIS + 1],
    int indx[BASIS + 1],
    double *d
) {
    double big;
    double dum;
    double sum;
    double temp;
    int i;
    int imax;
    int j;
    int k;

    *d = 1.;
    for (i = 1; i <= BASIS; i++) {
        big = 0.;
        for (j = 1; j <= BASIS; j++)
            if ((temp = fabs(a[i][j])) > big)
                big = temp;
        if (big == 0.)
            cleanup("Singular matrix in routine ludcmp");
        vv[i] = 1. / big;
    }
    for (j = 1; j <= BASIS; j++) {
        for (i = 1; i < j; i++) {
            sum = a[i][j];
            for (k = 1; k < i; k++)
                sum -= a[i][k] * a[k][j];
            a[i][j] = sum;
        }
        big = 0.;
        imax = -1;
        for (i = j; i <= BASIS; i++) {
            sum = a[i][j];
            for (k = 1; k < j; k++)
                sum -= a[i][k] * a[k][j];
            a[i][j] = sum;
            if ((dum = vv[i] * fabs(sum)) >= big) {
                big = dum;
                imax = i;
            }
        }
        if (imax == -1)
            cleanup("imax index not found in routine ludcmp");
        if (j != imax) {
            for (k = 1; k <= BASIS; k++) {
                dum = a[imax][k];
                a[imax][k] = a[j][k];
                a[j][k] = dum;
            }
            *d = -(*d);
            vv[imax] = vv[j];
        }
        indx[j] = imax;
        if (a[j][j] == 0.)
            a[j][j] = TINY;
        if (j != BASIS) {
            dum = 1. / (a[j][j]);
            for (i = j + 1; i <= BASIS; i++)
                a[i][j] *= dum;
        }
    }
}


