// RandomSymbol() -- generates an array of random integers from 0 to max
//
//	Author:	Stephen E. Robinson
//			MEG Core Group
//			NIMH
//

#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <sys/time.h>
#include <rvelib.h>

void	RandomSymbol(
	short	*Symbol,		// Symbol[T] -- output random symbols
	int		T,				// number of samples
	int		Max				// maximum symbol
)

{
	int					t;		// sample index
	static unsigned int	n = 0;	// counter to assure randomness
	time_t				secs;	// system time

	// on each call, initialize seed using system time
	time(&secs);
	srandom((unsigned int)secs + n);
	n += 1;
	
	// fill array with random integers from 0 to Max
	for(t=0; t<T; t++)
		Symbol[t] = (short)(random() % Max);
}
