// SVDAllocate() - allocate memory for SVD arrays U, W, & V
//
//	Author:	Stephen E. Robinson (after Sarvas & Hamalainen)
//			Neuromagnetism Laboratory
//			Dept.of Neurology
//			Henry Ford Hospital
//			Detroit, MI
//			Copyright (c) 2007
//

#include <stdlib.h>
#include <geoms.h>
#include <lfulib.h>

void	SVDAllocate(
	SVD	*sp		// pointer to SVD structure
) {
	int		M;
	int		N;
	int		i;

	M = sp->M;
	N = sp->M;
	if(M < N)	// rows, M must be >= than columns, N
		cleanup("M must be >= N for SVD");
	if((sp->U = (double **)malloc((size_t)M * sizeof(double *))) == NULL)
		allocfailed("sp->U[]");
	for(i=0; i<M; i++)
		if((sp->U[i] = (double *)malloc((size_t)N * sizeof(double))) == NULL)
			allocfailed("sp->U[][]");
	if((sp->V = (double **)malloc((size_t)N * sizeof(double *))) == NULL)
		allocfailed("sp->V[]");
	for(i=0; i<N; i++)
		if((sp->V[i] = (double *)malloc((size_t)N * sizeof(double))) == NULL)
			allocfailed("sp->U[][]");
	if((sp->W = (double *)malloc((size_t)N * sizeof(double))) == NULL)
		allocfailed("sp->W[]");
}
