// rms() -- compute RMS of time series
//
//	Author:	Stephen E. Robinson
//			MEG Core Facility
//			NIMH
//

#include <math.h>
#include <lfulib.h>

double	rms(
	double	*x,		// x[t] -- time-series
	int		T		// number of points in time-series
)

{
	double	m2;
	int	t;

	if(T < 0)
		cleanup("can't compute rms from sample size < 0");
	for(t=0, m2=0.; t<T; t++)
		m2 += x[t] * x[t];
	return sqrt(m2 / (double)T);
}
