#! /usr/bin/env python

# Put a brain in a kd-tree, why not?

import numpy as np

print 'read file'
f = open("/tmp/moo") # this file contains a brain
nverts = int(f.readline())
ll = f.readlines()
f.close()

print 'parse'
K = 3
N = 3
b = np.zeros((nverts, K + N))
n = 0
for l in ll:
	a = np.array(map(float, l.split()))
	b[n, :] = a
	n += 1

# Here's where the fun begins.

from scipy.spatial import KDTree

print 'index'
k = KDTree(b[:, 0:K])

def getnorm(b, i):
	return b[i, K:]

def in_ball(k, b, j, mm):
	# get the verts in the ball
	x = k.query_ball_point(b[j, 0:3], .001 * mm)
	# get the normals
	y = map(lambda i, b=b: getnorm(b, i), x)
	# average normal
	yy = reduce(lambda a, b: a + b, y, 0) / len(y)
	l = np.sqrt(np.dot(yy, yy))
	# return the number in the ball, the mean normal, and its length
	return len(y), yy, l

print 'sample'
M = range(1000)
m = (np.arange(40) * .1)[1:]
for mm in m:
	totn = 0.
	totl = 0.
	for i in M:
		n, v, l = in_ball(k, b, np.random.randint(0, b.shape[0]), mm)
		totn += n
		totl += l
	n = totn / len(M)
	l = totl / len(M)
	print mm, n, l
