#! /usr/bin/python3

# Parse a .param file, return a dict

def ParseParam(filename):
    d = {}
    ll = open(filename).readlines()
    for l in ll:

        # Ignore all past a '#'

        l = l.partition('#')[0].split()
        if len(l) == 0:
            continue

        # Clean up the key name.

        key = l.pop(0)
        key = key.lower()

        # Perform a few handy conversions;
        # if it looks like a bool, make it a bool,
        # if it looks like a float, make it a float.
        # Otherwise just append it to the list.

        val = []
        for x in l:
            s = x.lower()
            if s == 'true' or s == 'yes' or s == 'y' or s == '1':
                x = True
            elif s == 'false' or s == 'no' or s == 'n' or s == '0':
                x = False
            else:
                try:
                    x = float(x)
                except ValueError:
                    pass
            val.append(x)

        # Convert 1-lists into single values.

        if len(val) == 1:
            val = val[0]

        # Save it.

        d[key] = val

    return d


import sys, pprint

d = ParseParam(sys.argv[1])
pprint.pprint(d)

import json

print(json.dumps(d))
