// definition of cortical mesh elements for coregistration of MEG with MRI

#ifndef H_MESH
#define H_MESH

typedef struct {
	double		vertex[3];			// mesh vertex
	double		v1[3];				// weakly-constrained source moment vector
	double		v2[3];				// strongly-constrained source moment vector
	double		z2;					// z^2 source metric (from strong constraints)
	double		angle;				// dot product of constrained & unconstrained moment vectors
	double		span;				// span of eigenvalues in 3x3 solution
	int			r1;					// rank of z^2
	int			r2;					// rank of angle
	int			ROIFlag;			// constrained ROI flag
	int			AFlag;				// angular limit flag
	int			ZFlag;				// z^2 limit flag
	int			VFlag;				// vertex acceptance flag
	int			MFlag;				// mesh flag (set for good all good vertices)
	int			MaxFlag;			// maxima flag
} MESHINFO;

#endif	// H_MESH
